/*
 * vdr-podcatcher - A plugin for the Linux Video Disk Recorder
 * Copyright (c) 2006 Tobias Grimm <vdr@e-tobi.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: itemmenupresenter.h 2518 2006-01-29 23:33:10Z svntobi $
 *
 */

#ifndef ___ITEMMENUPRESENTER_H
#define ___ITEMMENUPRESENTER_H

#include <vdr/osdbase.h>
#include "listmenupresenter.h"
#include "listmenu.h"
#include "feed.h"
#include "itembuttonsupdater.h"

class IServiceLocator;
class IItemMenu;

class ItemMenuPresenter: public IListMenuPresenter
{
    private:
        IServiceLocator& serviceLocator;
        Feed feed;
        ItemList displayedItems;
        IListMenu* menu;
        bool podcastsOnly;
        ItemButtonsUpdater itemButtonsUpdater;

    private:
        void TogglePodcastFilter();
        void UpdateMenu();
        void UpdateDownloadAndPlayButton(int selectedItem);
        void UpdateFilterButton();
        void UpdateItemList();
        void ShowItemView(Item item);
        void DownloadItem(Item item);
        void PlayItem(Item item);
        bool IsValidItemSelection(int selectedItem);
        bool ProcessItemAction(eKeys key, Item item);

    public:
        ItemMenuPresenter(IServiceLocator& serviceLocator, Feed feed);
        // <IListMenuPresenter>
        void Initialize(IListMenu* listMenu);
        eOSState ProcessKey(int selectedItem, eKeys Key, eOSState state);
        // </IListMenuPresenter>
};

#endif
